/**
 * Created by Noa on 13/04/2017.
 */
$(document).ready(function(){

    /*
     * Prototypes
     */
    String.prototype.supplant = function (o) {
        return this.replace(/{([^{}]*)}/g,
            function (a, b) {
                var r = o[b];
                return typeof r === 'string' || typeof r === 'number' ? r : a;
            }
        );
    };

    /**
     * Template string with data
     */
    function templating(data, template) {
        return template.supplant(data);
    }

    var states =  [

    ];

    var currentState = 0;

    function removeSection(element) {

        $(element.closest('tr')).remove();
    }

    function getDataFromJwt() {

        var jwt  = $.cookie('jwt');

        return JSON.parse(atob(jwt.split('.')[1]));
    }

    function addNewSection(data) {

        if (data === undefined) {

            data = {
                "name" : "section 1",
                "from" : "00:00",
                "to" : "00:00",
                "type" : "job"
            };
        }

        var template  = '<tr> \
                        <td> \
                            <div class="input-group"> \
                                <input type="text" class="form-control" placeholder="section" name="name[]" value="{name}"> \
                            </div> \
                        </td> \
                        <td> \
                            <select class="form-control" name="type[]">\
                                <option value="free-time">temp-libre</option>\
                                <option value="job">boulot</option>\
                            </select> \
                        </td> \
                        <td> \
                            <div class="input-group clockpicker col-sm-10"> \
                                <input type="text" class="form-control" value="{from}" name="from[]"> \
                                <span class="input-group-addon"> \
                                    <span class="glyphicon glyphicon-time"></span> \
                                </span> \
                            </div> \
                        </td> \
                        <td> \
                            <div class="input-group clockpicker col-sm-10"> \
                                <input type="text" class="form-control" value="{to}" name="to[]"> \
                                <span class="input-group-addon"> \
                                    <span class="glyphicon glyphicon-time"></span> \
                                </span> \
                            </div> \
                        </td> \
                        <td> \
                            <button type="button" class="btn btn-danger removeSection"><span class="glyphicon glyphicon-remove" aria-hidden="true"></span> Supprimer la section</button> \
                        </td> \
                    </tr>';


        var section = templating(data, template);

        $('#sectionsList').append(section);

        // set last inserted section typr
        var lastSection = $('#formSection table tbody tr').last();

        lastSection.find("option[value='"+data.type+"']").prop('selected', true);

        registerSectionEvent();
    }

    function registerSectionEvent() {

        $('.removeSection').click(function (event) {

            event.stopPropagation();

            removeSection(event.target);
        });

        $('.clockpicker').clockpicker({
            donetext : "Valider"
        });

    }


    function askBackend(url, data, callback) {

        initJWT(function() {
            $.ajax({

                url  : url,
                type : 'POST',
                data : data,
                success : function(result) {

                    $.cookie('jwt', result);
                    callback();
                }
            });
        });
    }


    function click () {

        var data = {
            time : Date.now(),
            jwt : $.cookie('jwt')
        };

        askBackend('/click', data, nextStep);
    }

    function updateSections(sections) {

        var data = {
            data : JSON.stringify(sections),
            jwt : $.cookie('jwt')
        };

        askBackend('/sections', data, function(){});

        states = sections.names;
    }

    function nextStep() {

        currentState++;
        if (currentState > Object.keys(states).length - 1) {
            currentState = 0;
        }

        update();
    }

    function initJWT(callback) {

        // init sections
        var data = {
               "sections":{
                  "data":[
                     {
                        "type":"job",
                        "name":"boulot 1",
                        "from":"09:00",
                        "to":"12:30"
                     },
                     {
                        "type":"free-time",
                        "name":"manger",
                        "from":"12:30",
                        "to":"14:00"
                     },
                     {
                        "type":"job",
                        "name":"boulot 2",
                        "from":"14:00",
                        "to":"17:30"
                     },
                     {
                        "type":"free-time",
                        "name":"fin",
                        "from":"17:30",
                        "to":"00:00"
                     }
                  ],
                  "names":[
                     "boulot 1",
                     "manger",
                     "boulot 2",
                     "fin"
                  ]
               }
        };

        if ($.cookie('jwt') === undefined) {

            $.post('/init',
             {
                data : JSON.stringify(data)
             },
             function (result) {
                 $.cookie('jwt', result);

                callback()
            });
        } else {

            callback();
        }
    }

    function update() {

        $('.button_text').text(states[currentState]);
        $('.button_text').attr('data-state', currentState);
    }

    function init() {

        // Init JWT if doesn't exist yet
        if ($.cookie('jwt') === undefined) {

            initJWT(initTemplate);

        } else {

            initTemplate();
        }
    }

    function initSection() {

        var data = getDataFromJwt();
        data.sections.data.forEach(function (section) {

            addNewSection(section);
        });

        states = data.sections.names;
    }

    function initTemplate() {

        initSection();
        update();

        $('.clockpicker').clockpicker({
            donetext : "Valider"
        });
    }

    $('.button_container').on('click', function (event) {

        event.stopPropagation();
        click();
    });

    $('.button_text').on('click', function (event) {

        event.stopPropagation();
        var state = $(event.target).attr("data-state");
        click(state);
    });

    $('.tabs').on('click', function(event) {

        event.stopPropagation();
        var id = event.target.id;

        $('.noa-container').each(function(key, value) {
            $(value).addClass('hide');
        });

        $("#"+id+"_content").removeClass('hide');
    });

    $('#addNewSection').click(function (event) {

        addNewSection();
    });

    $("#formSection").submit(function (event) {

        event.preventDefault();

        var data = $("#formSection").serializeArray().reduce(function(obj, item) {

            if (item.name.slice(-2) === '[]') {

                if (Object.keys(obj).indexOf(item.name.slice(0,-2)) === -1) {
                    obj[item.name.slice(0,-2)] = [];
                }

                obj[item.name.slice(0,-2)].push(item.value);

            } else {

                obj[item.name] = item.value;
            }
            return obj;
        }, {});

        if (Object.keys(data).length) {

            var sections = {
                data : [],
                names : []
            };

            for (var i = 0; i < Object.keys(data.name).length; i++) {

                sections.data.push({
                    type : data['type'][i],
                    name : data['name'][i],
                    from : data['from'][i],
                    to : data['to'][i],

                });

                sections.names.push(data['name'][i]);
            }

            updateSections(sections);
        }

    })

    init();

});